var mgAppInfo =
{
   getAppInfo : function()
   {
      var pHandler = Components.classes['@mozilla.org/network/io-service;1']
                    .getService(Components.interfaces.nsIIOService)
                    .getProtocolHandler('http')
                    .QueryInterface(Components.interfaces.nsIHttpProtocolHandler);

      this.geckoVersion = pHandler.misc.substring(3);
      this.oscpu = pHandler.oscpu;
      this.platform = pHandler.platform;

      if ("@mozilla.org/xre/app-info;1" in Components.classes)
      {
         var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                       .getService(Components.interfaces.nsIXULAppInfo);

         this.appBuildID = appInfo.appBuildID;
         this.geckoBuildID = appInfo.geckoBuildID;
         this.ID = appInfo.ID;
         this.name = appInfo.name;
         try { // there is no nsIXULRuntime in SM
           this.os = appInfo.QueryInterface(Components.interfaces.nsIXULRuntime).OS;
         }
         catch (e) {
           this.os = false;
         }
         this.vendor = appInfo.vendor;
         this.version = appInfo.version;
      }
      else // for gecko < 1.8
      {
         if ("@mozilla.org/extensions/manager;1" in Components.classes)
         {
            this.name = "Firefox";
            if ("nsIPop3Service" in Components.interfaces)
               this.name = "Thunderbird";
         }
         else
            this.name = "SeaMonkey";
      }
   }
}

mgAppInfo.getAppInfo();
